
/*
Here is some code i have used for GL to create cube invironment maps

  This  first function creates alook up table where all pixels get its own vector:
*/

void create_vector_cube(float *data, unsigned int size)
{
	unsigned int i, j;
	float half_size, x, y, z, r;
	half_size = (float)(size * 0.5) - 0.5;

	for(i = 0; i < size; i++)
	{
		for(j = 0; j < size; j++)
		{
			x = half_size;
			y = half_size - (float)i;
			z = half_size - (float)j;
			r = sqrt(x * x + y * y + z * z);
			*data++ = x / r;
			*data++ = y / r;
			*data++ = z / r;
		}
	}
	for(i = 0; i < size; i++)
	{
		for(j = 0; j < size; j++)
		{
			x = (float)j - half_size;
			y = half_size;
			z = (float)i - half_size;
			r = sqrt(x * x + y * y + z * z);
			*data++ = x / r;
			*data++ = y / r;
			*data++ = z / r;			
		}
	}
	for(i = 0; i < size; i++)
	{
		for(j = 0; j < size; j++)
		{
			x = (float)j - half_size;
			y = half_size - (float)i;
			z = half_size;		
			r = sqrt(x * x + y * y + z * z);
			*data++ = x / r;
			*data++ = y / r;
			*data++ = z / r;
		}
	}
	for(i = 0; i < size; i++)
	{
		for(j = 0; j < size; j++)
		{
			x = -half_size;
			y = half_size - (float)i;
			z = (float)j - half_size;		
			r = sqrt(x * x + y * y + z * z);
			*data++ = x / r;
			*data++ = y / r;
			*data++ = z / r;
		}
	} 
	for(i = 0; i < size; i++)
	{
		for(j = 0; j < size; j++)
		{
			x = (float)j - half_size;
			y = -half_size;
			z = half_size - (float)i;		
			r = sqrt(x * x + y * y + z * z);
			*data++ = x / r;
			*data++ = y / r;
			*data++ = z / r;
		}
	}
	for(i = 0; i < size; i++)
	{
		for(j = 0; j < size; j++)
		{
			x = half_size - (float)j;
			y = half_size - (float)i;
			z = -half_size;		
			r = sqrt(x * x + y * y + z * z);
			*data++ = x / r;
			*data++ = y / r;
			*data++ = z / r;
		}
	}	
}
/*
This cunction gives you a pixel if if you have a normalized vector
*/
unsigned int find_pixel(float x, float y, float z,unsigned int size)
{
	unsigned int i, j, found;
	float r, half_size;

	half_size = 0.5 * (float)size;

	r = x;
	found = 0;
	if(y > r)
	{
		r = y;
		found = 1;
	}
	if(z > r)
	{
		r = z;
		found = 2;
	}
	if(-x > r)
	{
		r = -x;
		found = 3;
	}
	if(-y > r)
	{
		r = -y;
		found = 4;
	}
	if(-z > r)
	{
		r = -z;
		found = 5;
	}
	switch(found)
	{
		case 0 :
		i = size - ((y / x) + 1.0) * half_size;
		j = size - ((z / x) + 1.0) * half_size;
		return i * size + j;
		break;
		case 1 :
		i = ((x / y) + 1.0) * half_size;
		j = ((z / y) + 1.0) * half_size;
		return i * size + j + size * size;			
		break;
		case 2 :
		i = size - ((y / z) + 1.0) * half_size;
		j = ((x / z) + 1.0) * half_size;
		return i * size + j + size * size * 2;
		break;
		case 3 :
		i = size - ((y / -x) + 1.0) * half_size;
		j = ((z / -x) + 1.0) * half_size;
		return i * size + j + size * size * 3;
		break;
		case 4 :
		i = size - ((z / -y) + 1.0) * half_size;
		j = ((x / -y) + 1.0) * half_size;
		return i * size + j + size * size * 4;
		break;
		case 5 :
		i = size - ((y / -z) + 1.0) * half_size;
		j = size - ((x / -z) + 1.0) * half_size;
		return i * size + j + size * size * 5;
		break;
	}
	return 0;
}
/*

This is a function that i use to creat the environment sky in the demos.
*/

void create_sky(float *vector, float *data, float r, float g, float b, float hight)
{
	int i;
	float temp;
	hight = 1 - (1 / (hight + 2));
	for(i = 0; i < TEX_SIZE * TEX_SIZE * 6; i++)
	{
		temp = vector[i * 3 + 1];
		if(vector[i * 3 + 1] > 0) /* if the vector for the pixel is above the horizon we draw sky */
		{
			data[i * 3] = 0.2 * r;
			data[i * 3 + 1] = 0.4 * g;
			data[i * 3 + 2] = 0.6 * b;
		}
		else /* if the vector for the pixel is below the horizon we draw ground */
		{
			data[i * 3] = 0.13 *  hight * r;
			data[i * 3 + 1] = 0.38 * hight * g;
			data[i * 3 + 2] = 0.51 * hight * b;
		}
	}
}

/*
here is a function that creates a buffere, panits in objects, smoothes it and gives it to GL
*/
void setup_qubemapping()
{
	int i, j;
	float	x, y, brightnes;
	float vector[TEX_SIZE * TEX_SIZE * 3 * 6];
	float env[TEX_SIZE * TEX_SIZE * 3 * 6];
	float data[TEX_SIZE * TEX_SIZE * 3 * 6];

	glGenTextures(1, &texture_id);
	glEnable(GL_TEXTURE_CUBE_MAP_EXT);
	glBindTexture(GL_TEXTURE_CUBE_MAP_EXT, texture_id);
	
	create_vector_cube(vector, TEX_SIZE); /* ve need  a vector table */
	create_sky(env, data, 1, 1, 1, 1); /* creating sky */

/* here you can draw in more objects in to your environment */

	qube_threw_qube(vector, env, data, TEX_SIZE); /* making the environment diffuse */

	glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_X_EXT, 0, GL_RGB, TEX_SIZE, TEX_SIZE, 0, GL_RGB, GL_FLOAT, data); 
	glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Y_EXT, 0, GL_RGB, TEX_SIZE, TEX_SIZE, 0, GL_RGB, GL_FLOAT, &data[TEX_SIZE * TEX_SIZE * 3]); 
	glTexImage2D(GL_TEXTURE_CUBE_MAP_POSITIVE_Z_EXT, 0, GL_RGB, TEX_SIZE, TEX_SIZE, 0, GL_RGB, GL_FLOAT, &data[TEX_SIZE * TEX_SIZE * 3 * 2]); 
	glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_X_EXT, 0, GL_RGB, TEX_SIZE, TEX_SIZE, 0, GL_RGB, GL_FLOAT, &data[TEX_SIZE * TEX_SIZE * 3 * 3]); 
	glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Y_EXT, 0, GL_RGB, TEX_SIZE, TEX_SIZE, 0, GL_RGB, GL_FLOAT, &data[TEX_SIZE * TEX_SIZE * 3 * 4]); 
	glTexImage2D(GL_TEXTURE_CUBE_MAP_NEGATIVE_Z_EXT, 0, GL_RGB, TEX_SIZE, TEX_SIZE, 0, GL_RGB, GL_FLOAT, &data[TEX_SIZE * TEX_SIZE * 3 * 5]); 
	glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_CUBE_MAP_EXT, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

	glEnable(GL_TEXTURE_GEN_S);
	glEnable(GL_TEXTURE_GEN_T);
	glEnable(GL_TEXTURE_GEN_R);
	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT); /*be sure to use "normal map", not "reflection map"*/
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
	glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_NORMAL_MAP_EXT);
	
}

/* here is a snippet of code that draws in all objects surrounding on object in its environment map */
	for(i = 0; i < OBJECT_COUNT; i++)
	{
		if(i != object)
		{
			r = 0;
			g = 0;
			b = 0;
			x = scene->objects[object].pos.x - scene->objects[i].pos.x;
			y = scene->objects[object].pos.y - scene->objects[i].pos.y;
			z = scene->objects[object].pos.z - scene->objects[i].pos.z;
			a = sqrt(x * x + y * y + z * z);
			x = x / a;
			y = y / a;
			z = z / a;
			for(j = 0; j < LIGHT_COUNT; j++)
			{
				/* compute half vector */
				x2 = scene->lights[j].pos.x - scene->objects[i].pos.x;
				y2 = scene->lights[j].pos.y - scene->objects[i].pos.y;
				z2 = scene->lights[j].pos.z - scene->objects[i].pos.z;
				a2 = sqrt(x * x + y * y + z * z);
				x2 = x2 / a2;
				y2 = y2 / a2;
				z2 = z2 / a2;

				x2 += x;
				y2 += y;
				z2 += z;
				a2 = sqrt(x * x + y * y + z * z);
				x2 = x2 / a2;
				y2 = y2 / a2;
				z2 = z2 / a2;

				/* computing how the light */

				a2 = (x2 / (scene->lights[j].pos.x - scene->objects[i].pos.x) + y2 / (scene->lights[j].pos.y - scene->objects[i].pos.y) + z2 / (scene->lights[j].pos.z - scene->objects[i].pos.z));
			
				/* light is multiplyed by the color of the light bouncing object and the light source */
				
				r += (scene->objects[i].col.r * scene->lights[j].col.r) * a2;
				g += (scene->objects[i].col.g * scene->lights[j].col.g) * a2;
				b += (scene->objects[i].col.b * scene->lights[j].col.b) * a2;

			}

			r = (r / a) * scene->objects[i].col.r + scene->objects[i].col.r * 0.01 / a;
			g = (g / a) * scene->objects[i].col.g + scene->objects[i].col.g * 0.01 / a;
			b = (b / a) * scene->objects[i].col.b + scene->objects[i].col.b * 0.01 / a;
			draw_pixel(vector, data2, 0.7, -x, -y, -z, r * scene->objects[object].col.r * 100, g * scene->objects[object].col.g * 100, b * scene->objects[object].col.b * 100);
		}
	}

/* i hope this helped, i havent tested this code much i just ripped it out for you to have something to look at */